/*
 * @file BasicMath_Im.c
 * Module Interface for Module BasicMath_Im
 */

#include "BasicMath_Im.h"
#include <stdio.h>

void BasicMath_Im__INITIALIZE__received(BasicMath_Im__context *context)
{
   /* User Code Here */
}

void BasicMath_Im__START__received(BasicMath_Im__context *context)
{
   /* User Code Here */
}

void BasicMath_Im__STOP__received(BasicMath_Im__context *context)
{
   /* User Code Here */
}

void BasicMath_Im__SHUTDOWN__received(BasicMath_Im__context *context)
{
   /* User Code Here */
}

void BasicMath_Im__add__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 value1,
    const ECOA__int32 value2)
{
   // The behaviour of the add operation is:
   // Undefined if the service is not "functionally" available. The module does not check the state before responding!

   ECOA__return_status status;

   ECOA__int32 result = value1 + value2;
   status = BasicMath_Im_container__add__response_send(context, ID, result);
}

void BasicMath_Im__subtract__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 value1,
    const ECOA__int32 value2)
{
   // The behaviour of the subtract operation is:
   // Check if the service is available.
   // If it is available, send a response.
   // If it is not available, do not send a response.

   ECOA__return_status status;

   if (context->user.available)
   {
      ECOA__int32 result = value1 - value2;
      status = BasicMath_Im_container__subtract__response_send(context, ID, result);
   }
}

void BasicMath_Im__multiply__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 value1,
    const ECOA__int32 value2)
{
   // The behaviour of the multiply operation is:
   // Check if the service is available.
   // If it is available, send a response.
   // If it is not available, send a response, but with a default value.

   ECOA__return_status status;
   ECOA__int32 result = 0;

   if (context->user.available)
   {
      result = value1 * value2;
      status = BasicMath_Im_container__multiply__response_send(context, ID, result);
   }
   else
   {
      status = BasicMath_Im_container__multiply__response_send(context, ID, result);
   }
}

void BasicMath_Im__divide__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__int32 value1,
    const ECOA__int32 value2)
{
   // The behaviour of the divide operation is:
   // Check if the service is available.
   // If it is available, send a response.
   // If it is not available, send a response, but with an "Unavailable" status and default value.

   ECOA__return_status status;
   ECOA__int32 result = 0;
   BasicMath__Divide_Status_Type divideStatus = BasicMath__Divide_Status_Type_OK;

   if (context->user.available)
   {
      ECOA__int32 result = value1 / value2;
      status = BasicMath_Im_container__divide__response_send(context, ID, result, divideStatus);
   }
   else
   {
      // Return not available.
      divideStatus = BasicMath__Divide_Status_Type_Unavailable;
      status = BasicMath_Im_container__divide__response_send(context, ID, result, divideStatus);
   }
}

void BasicMath_Im__functionalInitialize__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID)
{
   // Add an artificial delay (to mimic a heavy-weight initialisation process).
   int i,j;
   for (i; i <= 500000000; i++)
   {
      while (j <= 500000000)
      {
         j++;
      }
   }
   BasicMath_Im_container__functionalInitialize__response_send(context, ID);
}
void BasicMath_Im__functionalStart__request_received
   (BasicMath_Im__context* context,
    const ECOA__uint32 ID)
{
   BasicMath_Im_container__functionalStart__response_send(context, ID);
}

void BasicMath_Im__available__updated(BasicMath_Im__context* context)
{
   BasicMath_Im_container__available_handle availableHandle;

   ECOA__return_status status = BasicMath_Im_container__available__get_read_access(context, &availableHandle);

   if (status == ECOA__return_status_OK)
   {
      // Update user context state.
      context->user.available = *(availableHandle.data);
      status = BasicMath_Im_container__available__release_read_access(context, &availableHandle);
   }
}
