/* @file Manager_Im_user_context.h
 * This is an example of a user defined User Module context
 */

#if !defined(MANAGER_IM_USER_CONTEXT_H)
#define MANAGER_IM_USER_CONTEXT_H

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Container Types */
#include "Manager_Im_container_types.h"

typedef enum {
   UNINITIALIZED,
   INITIALIZED,
   RUNNING
} moduleStateType;


/* User Module Context structure example */
typedef struct
{
   /* declare the User Module Context "local" data here */
   moduleStateType basicMathState;
   moduleStateType complexMathState;
   ECOA__boolean8 basicMathServiceAvailable;
   ECOA__uint8 count;
} Manager_Im_user_context;

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* MANAGER_IM_USER_CONTEXT_H */
